/*
 * Signed-off-by: Diego Hernan Borghetti.
 */

#include "../CMP_util.h"
#include <time.h>


/* ************** Frame Info ************** */
static bNodeSocketType cmp_node_frame_info_in[]= {
	{ SOCK_RGBA, 1, "Image", 0.8f, 0.8f, 0.8f, 1.0f, 0.0f, 1.0f },
	{ SOCK_RGBA, 1, "Color", 1.0f, 1.0f, 1.0f, 1.0f, 0.0f, 1.0f },
	{ -1, 0, "" }
};

static bNodeSocketType cmp_node_frame_info_out[]= {
	{ SOCK_RGBA, 0, "Image", 0.8f, 0.8f, 0.8f, 1.0f, 0.0f, 1.0f },
	{ -1, 0, "" }
};

static unsigned char fontdata[95][12]={
    /* [ ] = */ {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
    /* [!] = */ {0x00,0x00,0x30,0x30,0x00,0x30,0x30,0x78,0x78,0x78,0x30,0x00},
    /* ["] = */ {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x24,0x66,0x66,0x66,0x00},
    /* [#] = */ {0x00,0x00,0x6c,0x6c,0xfe,0x6c,0x6c,0x6c,0xfe,0x6c,0x6c,0x00},
    /* [$] = */ {0x00,0x30,0x30,0xf8,0x0c,0x0c,0x78,0xc0,0xc0,0x7c,0x30,0x30},
    /* [%] = */ {0x00,0x00,0x8c,0xcc,0x60,0x30,0x18,0xcc,0xc4,0x00,0x00,0x00},
    /* [&] = */ {0x00,0x00,0x76,0xdc,0xcc,0xde,0xfa,0x70,0xd8,0xd8,0x70,0x00},
    /* ['] = */ {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x30,0x30,0x30,0x00},
    /* [(] = */ {0x00,0x00,0x0c,0x18,0x30,0x60,0x60,0x60,0x30,0x18,0x0c,0x00},
    /* [)] = */ {0x00,0x00,0x60,0x30,0x18,0x0c,0x0c,0x0c,0x18,0x30,0x60,0x00},
    /* [*] = */ {0x00,0x00,0x00,0x00,0x66,0x3c,0xff,0x3c,0x66,0x00,0x00,0x00},
    /* [+] = */ {0x00,0x00,0x00,0x00,0x18,0x18,0x7e,0x18,0x18,0x00,0x00,0x00},
    /* [,] = */ {0x00,0x60,0x38,0x38,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
    /* [-] = */ {0x00,0x00,0x00,0x00,0x00,0x00,0xfe,0x00,0x00,0x00,0x00,0x00},
    /* [.] = */ {0x00,0x00,0x38,0x38,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
    /* [/] = */ {0x00,0x00,0x80,0xc0,0x60,0x30,0x18,0x0c,0x06,0x02,0x00,0x00},
    /* [0] = */ {0x00,0x00,0x7c,0xc6,0xe6,0xf6,0xd6,0xde,0xce,0xc6,0x7c,0x00},
    /* [1] = */ {0x00,0x00,0xfc,0x30,0x30,0x30,0x30,0x30,0xf0,0x30,0x10,0x00},
    /* [2] = */ {0x00,0x00,0xfc,0xcc,0x60,0x30,0x18,0x0c,0xcc,0xcc,0x78,0x00},
    /* [3] = */ {0x00,0x00,0x78,0xcc,0x0c,0x0c,0x38,0x0c,0x0c,0xcc,0x78,0x00},
    /* [4] = */ {0x00,0x00,0x1e,0x0c,0x0c,0xfe,0xcc,0x6c,0x3c,0x1c,0x0c,0x00},
    /* [5] = */ {0x00,0x00,0x78,0xcc,0x0c,0x0c,0xf8,0xc0,0xc0,0xc0,0xfc,0x00},
    /* [6] = */ {0x00,0x00,0x78,0xcc,0xcc,0xcc,0xf8,0xc0,0xc0,0x60,0x38,0x00},
    /* [7] = */ {0x00,0x00,0x30,0x30,0x30,0x18,0x0c,0x06,0xc6,0xc6,0xfe,0x00},
    /* [8] = */ {0x00,0x00,0x78,0xcc,0xcc,0xdc,0x78,0xec,0xcc,0xcc,0x78,0x00},
    /* [9] = */ {0x00,0x00,0x70,0x30,0x18,0x18,0x7c,0xcc,0xcc,0xcc,0x78,0x00},
    /* [:] = */ {0x00,0x00,0x00,0x38,0x38,0x00,0x00,0x38,0x38,0x00,0x00,0x00},
    /* [;] = */ {0x00,0x30,0x18,0x38,0x38,0x00,0x00,0x38,0x38,0x00,0x00,0x00},
    /* [<] = */ {0x00,0x00,0x0c,0x18,0x30,0x60,0xc0,0x60,0x30,0x18,0x0c,0x00},
    /* [=] = */ {0x00,0x00,0x00,0x00,0x00,0x7e,0x00,0x7e,0x00,0x00,0x00,0x00},
    /* [>] = */ {0x00,0x00,0x60,0x30,0x18,0x0c,0x06,0x0c,0x18,0x30,0x60,0x00},
    /* [?] = */ {0x00,0x00,0x30,0x30,0x00,0x30,0x30,0x18,0x0c,0xcc,0x78,0x00},
    /* [@] = */ {0x00,0x00,0x7c,0xc0,0xc0,0xde,0xde,0xde,0xc6,0xc6,0x7c,0x00},
    /* [A] = */ {0x00,0x00,0xcc,0xcc,0xcc,0xfc,0xcc,0xcc,0xcc,0x78,0x30,0x00},
    /* [B] = */ {0x00,0x00,0xfc,0x66,0x66,0x66,0x7c,0x66,0x66,0x66,0xfc,0x00},
    /* [C] = */ {0x00,0x00,0x3c,0x66,0xc6,0xc0,0xc0,0xc0,0xc6,0x66,0x3c,0x00},
    /* [D] = */ {0x00,0x00,0xf8,0x6c,0x66,0x66,0x66,0x66,0x66,0x6c,0xf8,0x00},
    /* [E] = */ {0x00,0x00,0xfe,0x62,0x60,0x64,0x7c,0x64,0x60,0x62,0xfe,0x00},
    /* [F] = */ {0x00,0x00,0xf0,0x60,0x60,0x64,0x7c,0x64,0x62,0x66,0xfe,0x00},
    /* [G] = */ {0x00,0x00,0x3e,0x66,0xc6,0xce,0xc0,0xc0,0xc6,0x66,0x3c,0x00},
    /* [H] = */ {0x00,0x00,0xcc,0xcc,0xcc,0xcc,0xfc,0xcc,0xcc,0xcc,0xcc,0x00},
    /* [I] = */ {0x00,0x00,0x78,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x78,0x00},
    /* [J] = */ {0x00,0x00,0x78,0xcc,0xcc,0xcc,0x0c,0x0c,0x0c,0x0c,0x1e,0x00},
    /* [K] = */ {0x00,0x00,0xe6,0x66,0x6c,0x6c,0x78,0x6c,0x6c,0x66,0xe6,0x00},
    /* [L] = */ {0x00,0x00,0xfe,0x66,0x66,0x62,0x60,0x60,0x60,0x60,0xf0,0x00},
    /* [M] = */ {0x00,0x00,0xc6,0xc6,0xc6,0xc6,0xd6,0xfe,0xfe,0xee,0xc6,0x00},
    /* [N] = */ {0x00,0x00,0xc6,0xc6,0xce,0xde,0xfe,0xf6,0xe6,0xc6,0xc6,0x00},
    /* [O] = */ {0x00,0x00,0x38,0x6c,0xc6,0xc6,0xc6,0xc6,0xc6,0x6c,0x38,0x00},
    /* [P] = */ {0x00,0x00,0xf0,0x60,0x60,0x60,0x7c,0x66,0x66,0x66,0xfc,0x00},
    /* [Q] = */ {0x00,0x1e,0x0c,0x7c,0xde,0xce,0xc6,0xc6,0xc6,0x6c,0x38,0x00},
    /* [R] = */ {0x00,0x00,0xe6,0x66,0x66,0x6c,0x7c,0x66,0x66,0x66,0xfc,0x00},
    /* [S] = */ {0x00,0x00,0x78,0xcc,0xcc,0x18,0x70,0xc0,0xcc,0xcc,0x78,0x00},
    /* [T] = */ {0x00,0x00,0x78,0x30,0x30,0x30,0x30,0x30,0x30,0xb4,0xfc,0x00},
    /* [U] = */ {0x00,0x00,0x78,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x00},
    /* [V] = */ {0x00,0x00,0x30,0x78,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x00},
    /* [W] = */ {0x00,0x00,0x6c,0x6c,0x6c,0xd6,0xd6,0xc6,0xc6,0xc6,0xc6,0x00},
    /* [X] = */ {0x00,0x00,0xcc,0xcc,0xcc,0x78,0x30,0x78,0xcc,0xcc,0xcc,0x00},
    /* [Y] = */ {0x00,0x00,0x78,0x30,0x30,0x30,0x78,0xcc,0xcc,0xcc,0xcc,0x00},
    /* [Z] = */ {0x00,0x00,0xfe,0xc6,0x62,0x60,0x30,0x18,0x98,0xce,0xfe,0x00},
    /* [[] = */ {0x00,0x00,0x3c,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x3c,0x00},
    /* [\] = */ {0x00,0x00,0x02,0x06,0x0c,0x18,0x30,0x60,0xc0,0x80,0x00,0x00},
    /* []] = */ {0x00,0x00,0x3c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x3c,0x00},
    /* [^] = */ {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xc6,0x6c,0x38,0x10},
    /* [_] = */ {0x00,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
    /* [`] = */ {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x30,0x30},
    /* [a] = */ {0x00,0x00,0x76,0xcc,0xcc,0x7c,0x0c,0x78,0x00,0x00,0x00,0x00},
    /* [b] = */ {0x00,0x00,0xdc,0x66,0x66,0x66,0x66,0x7c,0x60,0x60,0xe0,0x00},
    /* [c] = */ {0x00,0x00,0x78,0xcc,0xc0,0xc0,0xcc,0x78,0x00,0x00,0x00,0x00},
    /* [d] = */ {0x00,0x00,0x76,0xcc,0xcc,0xcc,0xcc,0x7c,0x0c,0x0c,0x1c,0x00},
    /* [e] = */ {0x00,0x00,0x78,0xcc,0xc0,0xfc,0xcc,0x78,0x00,0x00,0x00,0x00},
    /* [f] = */ {0x00,0x00,0xf0,0x60,0x60,0x60,0xf8,0x60,0x60,0x6c,0x38,0x00},
    /* [g] = */ {0x78,0xcc,0x0c,0x7c,0xcc,0xcc,0xcc,0x76,0x00,0x00,0x00,0x00},
    /* [h] = */ {0x00,0x00,0xe6,0x66,0x66,0x66,0x76,0x6c,0x60,0x60,0xe0,0x00},
    /* [i] = */ {0x00,0x00,0x7e,0x18,0x18,0x18,0x18,0x78,0x00,0x18,0x18,0x00},
    /* [j] = */ {0x78,0xcc,0xcc,0x0c,0x0c,0x0c,0x0c,0x3c,0x00,0x0c,0x0c,0x00},
    /* [k] = */ {0x00,0x00,0xe6,0x66,0x6c,0x78,0x6c,0x66,0x60,0x60,0xe0,0x00},
    /* [l] = */ {0x00,0x00,0x7e,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x78,0x00},
    /* [m] = */ {0x00,0x00,0xc6,0xd6,0xd6,0xd6,0xd6,0xfc,0x00,0x00,0x00,0x00},
    /* [n] = */ {0x00,0x00,0xcc,0xcc,0xcc,0xcc,0xcc,0xf8,0x00,0x00,0x00,0x00},
    /* [o] = */ {0x00,0x00,0x78,0xcc,0xcc,0xcc,0xcc,0x78,0x00,0x00,0x00,0x00},
    /* [p] = */ {0xf0,0x60,0x7c,0x66,0x66,0x66,0x66,0xdc,0x00,0x00,0x00,0x00},
    /* [q] = */ {0x1e,0x0c,0x7c,0xcc,0xcc,0xcc,0xcc,0x76,0x00,0x00,0x00,0x00},
    /* [r] = */ {0x00,0x00,0xf0,0x60,0x60,0x76,0x6e,0xec,0x00,0x00,0x00,0x00},
    /* [s] = */ {0x00,0x00,0x78,0xcc,0x18,0x60,0xcc,0x78,0x00,0x00,0x00,0x00},
    /* [t] = */ {0x00,0x00,0x38,0x6c,0x60,0x60,0x60,0xfc,0x60,0x20,0x00,0x00},
    /* [u] = */ {0x00,0x00,0x76,0xcc,0xcc,0xcc,0xcc,0xcc,0x00,0x00,0x00,0x00},
    /* [v] = */ {0x00,0x00,0x30,0x78,0xcc,0xcc,0xcc,0xcc,0x00,0x00,0x00,0x00},
    /* [w] = */ {0x00,0x00,0x6c,0x6c,0xd6,0xd6,0xc6,0xc6,0x00,0x00,0x00,0x00},
    /* [x] = */ {0x00,0x00,0xc6,0x6c,0x38,0x38,0x6c,0xc6,0x00,0x00,0x00,0x00},
    /* [y] = */ {0xf0,0x18,0x0c,0x3c,0x66,0x66,0x66,0x66,0x00,0x00,0x00,0x00},
    /* [z] = */ {0x00,0x00,0xfc,0xc4,0x60,0x18,0x8c,0xfc,0x00,0x00,0x00,0x00},
    /* [{] = */ {0x00,0x00,0x1c,0x30,0x30,0x60,0xc0,0x60,0x30,0x30,0x1c,0x00},
    /* [|] = */ {0x00,0x00,0x18,0x18,0x18,0x18,0x00,0x18,0x18,0x18,0x18,0x00},
    /* [}] = */ {0x00,0x00,0xe0,0x30,0x30,0x18,0x0c,0x18,0x30,0x30,0xe0,0x00},
    /* [~] = */ {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xce,0xda,0x73,0x00},
};

static void do_draw_string(int x, int y, char *str, CompBuf *cbuf)
{
	int i, j, posx;
	char c;
	float *pixel, *max;
	unsigned char *bitmap;

	/* max memory address for this buffer */
	max= cbuf->rect+(cbuf->type*(cbuf->y*cbuf->x));
	posx= x;
	while((c= (unsigned char) *str++)) {
		c-= 32;
		if(c>0 || c<94) {
			bitmap= fontdata[c];
			for(j= 0; j<12; j++) {
				for(i= 0; i<8; i++) {
					/* get pixel location */
					pixel= cbuf->rect+cbuf->type*(((y+j)*cbuf->x)+(posx+i));
					/* if it's in the bounds of memory */
					if(pixel<max && pixel>cbuf->rect) {
						/* draw pixel */
						if(bitmap[j]&(0x80>>i)) {
							pixel[0]= 1.0;
							pixel[1]= 1.0;
							pixel[2]= 1.0;
							pixel[3]= 1.0;
						}
						else {
							pixel[0]= 0.5;
							pixel[1]= 0.5;
							pixel[2]= 0.5;
							pixel[3]= 1.0;
						}
					}
				}
			}
			posx+= 8;
		}
	}
}

/*
 * Based on the original sequencer plug-in to overlay frame information.
 */
static void node_composit_exec_frame_info(void *data, bNode *node, bNodeStack **in, bNodeStack **out)
{
	int max, yoff, topLength, bottomLength, tempLength, h, m, s, f;
	CompBuf *cbuf;
	CompBuf *rgbbuf;
	NodeFrameInfo *fi;
	char prstr[1024];

	if((!out[0]->hasoutput) || (!in[0]->hasinput))
		return;
	if(!in[0]->data)
		return;

	cbuf= in[0]->data;
	rgbbuf= dupalloc_compbuf(cbuf);

	if(cbuf->type==CB_RGBA) {
		max= cbuf->x*cbuf->y*4;
		fi= node->storage;

		/* determine length of top strip. */
		topLength= 0;
		yoff= 12;

		/* filename */
		if(node->custom1 & FRAME_INFO_FILENAME) {
			sprintf(prstr, "File: %s ", G.main->name);
			tempLength= strlen(prstr)*8;
			if(topLength+tempLength>cbuf->x) {
				yoff+= 12;
				topLength= 0;
			}
			do_draw_string(topLength, cbuf->y-yoff, prstr, rgbbuf);
			topLength+= tempLength;
		}

		/* camera name */
		if(node->custom1 & FRAME_INFO_CAMERA) {
			sprintf(prstr, "Camera: %s ", G.scene->camera->id.name);
			tempLength= strlen(prstr)*8;
			if(topLength+tempLength>cbuf->x) {
				yoff+= 12;
				topLength= 0;
			}
			do_draw_string(topLength, cbuf->y-yoff, prstr, rgbbuf);
			topLength+= tempLength;
		}

		/* scene name */
		if(node->custom1 & FRAME_INFO_SCENE) {
			sprintf(prstr, "Scene: %s ", G.scene->id.name);
			tempLength= strlen(prstr)*8;
			if(topLength+tempLength>cbuf->x) {
				yoff+= 12;
				topLength= 0;
			}
			do_draw_string(topLength, cbuf->y-yoff, prstr, rgbbuf);
			topLength+= tempLength;
		}

		/* determine length of bottom strip. */
		bottomLength= 0;
		yoff= 0;

		/* frame number */
		if(node->custom1 & FRAME_INFO_FRAME) {
			sprintf(prstr, "Frame: %i ", G.scene->r.cfra);
			tempLength= strlen(prstr)*8;
			if(bottomLength+tempLength>cbuf->x) {
				yoff+= 12;
				bottomLength= 0;
			}
			do_draw_string(bottomLength, yoff, prstr, rgbbuf);
			bottomLength+= tempLength;
		}

		/* timecode */
		if(node->custom1 & FRAME_INFO_TIMECODE) {
			f= s= m= h= 0;
			f= (int)(G.scene->r.cfra%G.scene->r.frs_sec);
			s= (int)(G.scene->r.cfra/G.scene->r.frs_sec);
			if(s) {
				m= (int)(s/60);
				s%= 60;
				if(m) {
					h= (int)(m/60);
					m%= 60;
				}
			}

			if(G.scene->r.frs_sec<100)
				sprintf(prstr, "Time: %02d:%02d:%02d:%02d ", h, m, s, f);
			else
				sprintf(prstr, "Time: %02d:%02d:%02d:%03d ", h, m, s, f);

			tempLength= strlen(prstr)*8;
			if(bottomLength+tempLength>cbuf->x) {
				yoff+= 12;
				bottomLength= 0;
			}
			do_draw_string(bottomLength, yoff, prstr, rgbbuf);
			bottomLength+= tempLength;
		}

		/* date */
		if(node->custom1 & FRAME_INFO_DATE) {
			char s[30];
			size_t i;
			struct tm tim;
			time_t now;

			now= time(NULL);
			tim= *(localtime(&now));
			i= strftime(s, 30, "%b %d, %Y; %H:%M:%S\n", &tim);

			sprintf(prstr, "Date: %s ", s);
			tempLength= strlen(prstr)*8;
			if(bottomLength+tempLength>cbuf->x) {
				yoff+= 12;
				bottomLength= 0;
			}
			do_draw_string(bottomLength, yoff, prstr, rgbbuf);
			bottomLength+= tempLength;
		}

		/* extra */
		if(strlen(fi->extra)>0) {
			sprintf(prstr, "Comment: %s ", fi->extra);
			tempLength= strlen(prstr)*8;
			if(bottomLength+tempLength>cbuf->x) {
				yoff+= 12;
				bottomLength= 0;
			}
			do_draw_string(bottomLength, yoff, prstr, rgbbuf);
			bottomLength+= tempLength;
		}
	}

	out[0]->data= rgbbuf;
}

void node_composit_init_frame_info(bNode *node)
{
	node->storage = MEM_callocN(sizeof(NodeFrameInfo), "node frame info");
}

bNodeType cmp_node_frame_info= {
	/* next, prev   */ NULL, NULL,
	/* type code    */ CMP_NODE_FRAME_INFO,
	/* name         */ "Frame Info",
	/* width+range  */ 200, 200, 250,
	/* class+opts   */ NODE_CLASS_OUTPUT, NODE_OPTIONS,
	/* input sock   */ cmp_node_frame_info_in,
	/* output sock  */ cmp_node_frame_info_out,
	/* storage      */ "NodeFrameInfo",
	/* execfunc     */ node_composit_exec_frame_info,
	/* butfunc      */ NULL,
	/* initfunc     */ node_composit_init_frame_info,
	/* freestoragefunc */ node_free_standard_storage,
	/* copystoragefunc */ node_copy_standard_storage,
	/* id           */ NULL
};
